<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FlightSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FlightSupplier extends AbstractStructArrayBase
{
    /**
     * The FlightSupplier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FlightSupplier[]
     */
    public $FlightSupplier;
    /**
     * Constructor method for ArrayOfJP_FlightSupplier
     * @uses ArrayOfJP_FlightSupplier::setFlightSupplier()
     * @param \StructType\JP_FlightSupplier[] $flightSupplier
     */
    public function __construct(array $flightSupplier = array())
    {
        $this
            ->setFlightSupplier($flightSupplier);
    }
    /**
     * Get FlightSupplier value
     * @return \StructType\JP_FlightSupplier[]|null
     */
    public function getFlightSupplier()
    {
        return $this->FlightSupplier;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightSupplier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightSupplier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightSupplierForArrayConstraintsFromSetFlightSupplier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FlightSupplierFlightSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FlightSupplierFlightSupplierItem instanceof \StructType\JP_FlightSupplier) {
                $invalidValues[] = is_object($arrayOfJP_FlightSupplierFlightSupplierItem) ? get_class($arrayOfJP_FlightSupplierFlightSupplierItem) : sprintf('%s(%s)', gettype($arrayOfJP_FlightSupplierFlightSupplierItem), var_export($arrayOfJP_FlightSupplierFlightSupplierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightSupplier property can only contain items of type \StructType\JP_FlightSupplier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplier[] $flightSupplier
     * @return \ArrayType\ArrayOfJP_FlightSupplier
     */
    public function setFlightSupplier(array $flightSupplier = array())
    {
        // validation for constraint: array
        if ('' !== ($flightSupplierArrayErrorMessage = self::validateFlightSupplierForArrayConstraintsFromSetFlightSupplier($flightSupplier))) {
            throw new \InvalidArgumentException($flightSupplierArrayErrorMessage, __LINE__);
        }
        $this->FlightSupplier = $flightSupplier;
        return $this;
    }
    /**
     * Add item to FlightSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplier $item
     * @return \ArrayType\ArrayOfJP_FlightSupplier
     */
    public function addToFlightSupplier(\StructType\JP_FlightSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FlightSupplier) {
            throw new \InvalidArgumentException(sprintf('The FlightSupplier property can only contain items of type \StructType\JP_FlightSupplier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FlightSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FlightSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FlightSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FlightSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FlightSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSupplier
     */
    public function getAttributeName()
    {
        return 'FlightSupplier';
    }
}
